// Copyright 2022 The Accumulate Authors
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

package staking

// GENERATED BY go run ./tools/cmd/gen-types. DO NOT EDIT.

//lint:file-ignore S1001,S1002,S1008,SA4013 generated code

import (
	"bytes"
	"encoding/json"
	"errors"
	"io"
	"strings"

	"gitlab.com/accumulatenetwork/accumulate/pkg/types/encoding"
	"gitlab.com/accumulatenetwork/accumulate/pkg/url"
)

type Account struct {
	fieldsSet []bool
	// Type is the type of staking account.
	Type AccountType `json:"type,omitempty" form:"type" query:"type" validate:"required"`
	// Url is the URL of the staked token account.
	Url *url.URL `json:"url,omitempty" form:"url" query:"url" validate:"required"`
	// Payout is the URL of the payout token account.
	Payout *url.URL `json:"payout,omitempty" form:"payout" query:"payout" validate:"required"`
	// Delegate is the URL of an account this stake is delegated to.
	Delegate *url.URL `json:"delegate,omitempty" form:"delegate" query:"delegate"`
	// Lockup is the number of quarters the tokens will be locked for, beyond the post-activation 6 months.
	Lockup uint64 `json:"lockup,omitempty" form:"lockup" query:"lockup"`
	// HardLock determines if the tokens can be withdrawn for a penalty (soft lock) or cannot be withdrawn at all (hard lock).
	HardLock  bool `json:"hardLock,omitempty" form:"hardLock" query:"hardLock"`
	extraData []byte
}

type Approved struct {
	fieldsSet []bool
	Identity  *url.URL `json:"identity,omitempty" form:"identity" query:"identity" validate:"required"`
	// Pure indicates whether the staker has been approved to be a pure staker.
	Pure bool `json:"pure,omitempty" form:"pure" query:"pure" validate:"required"`
	// Operator indicates whether the staker has been approved to be an operator.
	Operator  bool `json:"operator,omitempty" form:"operator" query:"operator" validate:"required"`
	extraData []byte
}

type Identity struct {
	fieldsSet []bool
	// Identity is the URL of the staker's ADI.
	Identity *url.URL   `json:"identity,omitempty" form:"identity" query:"identity" validate:"required"`
	Accounts []*Account `json:"accounts,omitempty" form:"accounts" query:"accounts" validate:"required"`
	// DelegatorPayout is the token account that rewards from delegators are sent to.
	DelegatorPayout *url.URL `json:"delegatorPayout,omitempty" form:"delegatorPayout" query:"delegatorPayout" validate:"required"`
	// RejectDelegates indicates this identity rejects delegates.
	RejectDelegates bool `json:"rejectDelegates,omitempty" form:"rejectDelegates" query:"rejectDelegates" validate:"required"`
	// Type is the type of staking account.
	Type AccountType `json:"type,omitempty" form:"type" query:"type" validate:"required"`
	// Stake is the URL of the staked token account.
	Stake *url.URL `json:"stake,omitempty" form:"stake" query:"stake" validate:"required"`
	// Rewards is the URL of the rewards token account.
	Rewards *url.URL `json:"rewards,omitempty" form:"rewards" query:"rewards" validate:"required"`
	// Delegate is the URL of an account this stake is delegated to.
	Delegate *url.URL `json:"delegate,omitempty" form:"delegate" query:"delegate"`
	// Lockup is the number of quarters the tokens will be locked for, beyond the post-activation 6 months.
	Lockup uint64 `json:"lockup,omitempty" form:"lockup" query:"lockup"`
	// HardLock determines if the tokens can be withdrawn for a penalty (soft lock) or cannot be withdrawn at all (hard lock).
	HardLock bool `json:"hardLock,omitempty" form:"hardLock" query:"hardLock"`
	// Status is the status of staking account.
	Status Status `json:"status,omitempty" form:"status" query:"status" validate:"required"`
	// AcceptingDelegates indicates if a full staker is accepting delegates.
	AcceptingDelegates AcceptingDelegates `json:"acceptingDelegates,omitempty" form:"acceptingDelegates" query:"acceptingDelegates" validate:"required"`
	extraData          []byte
}

func (v *Account) Copy() *Account {
	u := new(Account)

	u.Type = v.Type
	if v.Url != nil {
		u.Url = v.Url
	}
	if v.Payout != nil {
		u.Payout = v.Payout
	}
	if v.Delegate != nil {
		u.Delegate = v.Delegate
	}
	u.Lockup = v.Lockup
	u.HardLock = v.HardLock
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Account) CopyAsInterface() interface{} { return v.Copy() }

func (v *Approved) Copy() *Approved {
	u := new(Approved)

	if v.Identity != nil {
		u.Identity = v.Identity
	}
	u.Pure = v.Pure
	u.Operator = v.Operator
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Approved) CopyAsInterface() interface{} { return v.Copy() }

func (v *Identity) Copy() *Identity {
	u := new(Identity)

	if v.Identity != nil {
		u.Identity = v.Identity
	}
	u.Accounts = make([]*Account, len(v.Accounts))
	for i, v := range v.Accounts {
		v := v
		if v != nil {
			u.Accounts[i] = (v).Copy()
		}
	}
	if v.DelegatorPayout != nil {
		u.DelegatorPayout = v.DelegatorPayout
	}
	u.RejectDelegates = v.RejectDelegates
	u.Type = v.Type
	if v.Stake != nil {
		u.Stake = v.Stake
	}
	if v.Rewards != nil {
		u.Rewards = v.Rewards
	}
	if v.Delegate != nil {
		u.Delegate = v.Delegate
	}
	u.Lockup = v.Lockup
	u.HardLock = v.HardLock
	u.Status = v.Status
	u.AcceptingDelegates = v.AcceptingDelegates
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Identity) CopyAsInterface() interface{} { return v.Copy() }

func (v *Account) Equal(u *Account) bool {
	if !(v.Type == u.Type) {
		return false
	}
	switch {
	case v.Url == u.Url:
		// equal
	case v.Url == nil || u.Url == nil:
		return false
	case !((v.Url).Equal(u.Url)):
		return false
	}
	switch {
	case v.Payout == u.Payout:
		// equal
	case v.Payout == nil || u.Payout == nil:
		return false
	case !((v.Payout).Equal(u.Payout)):
		return false
	}
	switch {
	case v.Delegate == u.Delegate:
		// equal
	case v.Delegate == nil || u.Delegate == nil:
		return false
	case !((v.Delegate).Equal(u.Delegate)):
		return false
	}
	if !(v.Lockup == u.Lockup) {
		return false
	}
	if !(v.HardLock == u.HardLock) {
		return false
	}

	return true
}

func (v *Approved) Equal(u *Approved) bool {
	switch {
	case v.Identity == u.Identity:
		// equal
	case v.Identity == nil || u.Identity == nil:
		return false
	case !((v.Identity).Equal(u.Identity)):
		return false
	}
	if !(v.Pure == u.Pure) {
		return false
	}
	if !(v.Operator == u.Operator) {
		return false
	}

	return true
}

func (v *Identity) Equal(u *Identity) bool {
	switch {
	case v.Identity == u.Identity:
		// equal
	case v.Identity == nil || u.Identity == nil:
		return false
	case !((v.Identity).Equal(u.Identity)):
		return false
	}
	if len(v.Accounts) != len(u.Accounts) {
		return false
	}
	for i := range v.Accounts {
		if !((v.Accounts[i]).Equal(u.Accounts[i])) {
			return false
		}
	}
	switch {
	case v.DelegatorPayout == u.DelegatorPayout:
		// equal
	case v.DelegatorPayout == nil || u.DelegatorPayout == nil:
		return false
	case !((v.DelegatorPayout).Equal(u.DelegatorPayout)):
		return false
	}
	if !(v.RejectDelegates == u.RejectDelegates) {
		return false
	}
	if !(v.Type == u.Type) {
		return false
	}
	switch {
	case v.Stake == u.Stake:
		// equal
	case v.Stake == nil || u.Stake == nil:
		return false
	case !((v.Stake).Equal(u.Stake)):
		return false
	}
	switch {
	case v.Rewards == u.Rewards:
		// equal
	case v.Rewards == nil || u.Rewards == nil:
		return false
	case !((v.Rewards).Equal(u.Rewards)):
		return false
	}
	switch {
	case v.Delegate == u.Delegate:
		// equal
	case v.Delegate == nil || u.Delegate == nil:
		return false
	case !((v.Delegate).Equal(u.Delegate)):
		return false
	}
	if !(v.Lockup == u.Lockup) {
		return false
	}
	if !(v.HardLock == u.HardLock) {
		return false
	}
	if !(v.Status == u.Status) {
		return false
	}
	if !(v.AcceptingDelegates == u.AcceptingDelegates) {
		return false
	}

	return true
}

var fieldNames_Account = []string{
	1: "Type",
	2: "Url",
	3: "Payout",
	4: "Delegate",
	5: "Lockup",
	6: "HardLock",
}

func (v *Account) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.Type == 0) {
		writer.WriteEnum(1, v.Type)
	}
	if !(v.Url == nil) {
		writer.WriteUrl(2, v.Url)
	}
	if !(v.Payout == nil) {
		writer.WriteUrl(3, v.Payout)
	}
	if !(v.Delegate == nil) {
		writer.WriteUrl(4, v.Delegate)
	}
	if !(v.Lockup == 0) {
		writer.WriteUint(5, v.Lockup)
	}
	if !(!v.HardLock) {
		writer.WriteBool(6, v.HardLock)
	}

	_, _, err := writer.Reset(fieldNames_Account)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Account) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Type is missing")
	} else if v.Type == 0 {
		errs = append(errs, "field Type is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Url is missing")
	} else if v.Url == nil {
		errs = append(errs, "field Url is not set")
	}
	if len(v.fieldsSet) > 2 && !v.fieldsSet[2] {
		errs = append(errs, "field Payout is missing")
	} else if v.Payout == nil {
		errs = append(errs, "field Payout is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_Approved = []string{
	1: "Identity",
	2: "Pure",
	3: "Operator",
}

func (v *Approved) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.Identity == nil) {
		writer.WriteUrl(1, v.Identity)
	}
	if !(!v.Pure) {
		writer.WriteBool(2, v.Pure)
	}
	if !(!v.Operator) {
		writer.WriteBool(3, v.Operator)
	}

	_, _, err := writer.Reset(fieldNames_Approved)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Approved) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Identity is missing")
	} else if v.Identity == nil {
		errs = append(errs, "field Identity is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Pure is missing")
	} else if !v.Pure {
		errs = append(errs, "field Pure is not set")
	}
	if len(v.fieldsSet) > 2 && !v.fieldsSet[2] {
		errs = append(errs, "field Operator is missing")
	} else if !v.Operator {
		errs = append(errs, "field Operator is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_Identity = []string{
	1:  "Identity",
	2:  "Accounts",
	3:  "DelegatorPayout",
	4:  "RejectDelegates",
	5:  "Type",
	6:  "Stake",
	7:  "Rewards",
	8:  "Delegate",
	9:  "Lockup",
	10: "HardLock",
	11: "Status",
	12: "AcceptingDelegates",
}

func (v *Identity) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.Identity == nil) {
		writer.WriteUrl(1, v.Identity)
	}
	if !(len(v.Accounts) == 0) {
		for _, v := range v.Accounts {
			writer.WriteValue(2, v.MarshalBinary)
		}
	}
	if !(v.DelegatorPayout == nil) {
		writer.WriteUrl(3, v.DelegatorPayout)
	}
	if !(!v.RejectDelegates) {
		writer.WriteBool(4, v.RejectDelegates)
	}
	if !(v.Type == 0) {
		writer.WriteEnum(5, v.Type)
	}
	if !(v.Stake == nil) {
		writer.WriteUrl(6, v.Stake)
	}
	if !(v.Rewards == nil) {
		writer.WriteUrl(7, v.Rewards)
	}
	if !(v.Delegate == nil) {
		writer.WriteUrl(8, v.Delegate)
	}
	if !(v.Lockup == 0) {
		writer.WriteUint(9, v.Lockup)
	}
	if !(!v.HardLock) {
		writer.WriteBool(10, v.HardLock)
	}
	if !(v.Status == 0) {
		writer.WriteEnum(11, v.Status)
	}
	if !(v.AcceptingDelegates == 0) {
		writer.WriteEnum(12, v.AcceptingDelegates)
	}

	_, _, err := writer.Reset(fieldNames_Identity)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Identity) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Identity is missing")
	} else if v.Identity == nil {
		errs = append(errs, "field Identity is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Accounts is missing")
	} else if len(v.Accounts) == 0 {
		errs = append(errs, "field Accounts is not set")
	}
	if len(v.fieldsSet) > 2 && !v.fieldsSet[2] {
		errs = append(errs, "field DelegatorPayout is missing")
	} else if v.DelegatorPayout == nil {
		errs = append(errs, "field DelegatorPayout is not set")
	}
	if len(v.fieldsSet) > 3 && !v.fieldsSet[3] {
		errs = append(errs, "field RejectDelegates is missing")
	} else if !v.RejectDelegates {
		errs = append(errs, "field RejectDelegates is not set")
	}
	if len(v.fieldsSet) > 4 && !v.fieldsSet[4] {
		errs = append(errs, "field Type is missing")
	} else if v.Type == 0 {
		errs = append(errs, "field Type is not set")
	}
	if len(v.fieldsSet) > 5 && !v.fieldsSet[5] {
		errs = append(errs, "field Stake is missing")
	} else if v.Stake == nil {
		errs = append(errs, "field Stake is not set")
	}
	if len(v.fieldsSet) > 6 && !v.fieldsSet[6] {
		errs = append(errs, "field Rewards is missing")
	} else if v.Rewards == nil {
		errs = append(errs, "field Rewards is not set")
	}
	if len(v.fieldsSet) > 10 && !v.fieldsSet[10] {
		errs = append(errs, "field Status is missing")
	} else if v.Status == 0 {
		errs = append(errs, "field Status is not set")
	}
	if len(v.fieldsSet) > 11 && !v.fieldsSet[11] {
		errs = append(errs, "field AcceptingDelegates is missing")
	} else if v.AcceptingDelegates == 0 {
		errs = append(errs, "field AcceptingDelegates is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

func (v *Account) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Account) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x := new(AccountType); reader.ReadEnum(1, x) {
		v.Type = *x
	}
	if x, ok := reader.ReadUrl(2); ok {
		v.Url = x
	}
	if x, ok := reader.ReadUrl(3); ok {
		v.Payout = x
	}
	if x, ok := reader.ReadUrl(4); ok {
		v.Delegate = x
	}
	if x, ok := reader.ReadUint(5); ok {
		v.Lockup = x
	}
	if x, ok := reader.ReadBool(6); ok {
		v.HardLock = x
	}

	seen, err := reader.Reset(fieldNames_Account)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *Approved) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Approved) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUrl(1); ok {
		v.Identity = x
	}
	if x, ok := reader.ReadBool(2); ok {
		v.Pure = x
	}
	if x, ok := reader.ReadBool(3); ok {
		v.Operator = x
	}

	seen, err := reader.Reset(fieldNames_Approved)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *Identity) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Identity) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUrl(1); ok {
		v.Identity = x
	}
	for {
		if x := new(Account); reader.ReadValue(2, x.UnmarshalBinaryFrom) {
			v.Accounts = append(v.Accounts, x)
		} else {
			break
		}
	}
	if x, ok := reader.ReadUrl(3); ok {
		v.DelegatorPayout = x
	}
	if x, ok := reader.ReadBool(4); ok {
		v.RejectDelegates = x
	}
	if x := new(AccountType); reader.ReadEnum(5, x) {
		v.Type = *x
	}
	if x, ok := reader.ReadUrl(6); ok {
		v.Stake = x
	}
	if x, ok := reader.ReadUrl(7); ok {
		v.Rewards = x
	}
	if x, ok := reader.ReadUrl(8); ok {
		v.Delegate = x
	}
	if x, ok := reader.ReadUint(9); ok {
		v.Lockup = x
	}
	if x, ok := reader.ReadBool(10); ok {
		v.HardLock = x
	}
	if x := new(Status); reader.ReadEnum(11, x) {
		v.Status = *x
	}
	if x := new(AcceptingDelegates); reader.ReadEnum(12, x) {
		v.AcceptingDelegates = *x
	}

	seen, err := reader.Reset(fieldNames_Identity)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func init() {

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("type", "string"),
		encoding.NewTypeField("url", "string"),
		encoding.NewTypeField("payout", "string"),
		encoding.NewTypeField("delegate", "string"),
		encoding.NewTypeField("lockup", "uint64"),
		encoding.NewTypeField("hardLock", "bool"),
	}, "Account", "account")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("identity", "string"),
		encoding.NewTypeField("pure", "bool"),
		encoding.NewTypeField("operator", "bool"),
	}, "Approved", "approved")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("identity", "string"),
		encoding.NewTypeField("accounts", "Account[]"),
		encoding.NewTypeField("delegatorPayout", "string"),
		encoding.NewTypeField("rejectDelegates", "bool"),
		encoding.NewTypeField("type", "string"),
		encoding.NewTypeField("stake", "string"),
		encoding.NewTypeField("rewards", "string"),
		encoding.NewTypeField("delegate", "string"),
		encoding.NewTypeField("lockup", "uint64"),
		encoding.NewTypeField("hardLock", "bool"),
		encoding.NewTypeField("status", "string"),
		encoding.NewTypeField("acceptingDelegates", "string"),
	}, "Identity", "identity")

}

func (v *Identity) MarshalJSON() ([]byte, error) {
	u := struct {
		Identity           *url.URL                    `json:"identity,omitempty"`
		Accounts           encoding.JsonList[*Account] `json:"accounts,omitempty"`
		DelegatorPayout    *url.URL                    `json:"delegatorPayout,omitempty"`
		RejectDelegates    bool                        `json:"rejectDelegates,omitempty"`
		Type               AccountType                 `json:"type,omitempty"`
		Stake              *url.URL                    `json:"stake,omitempty"`
		Rewards            *url.URL                    `json:"rewards,omitempty"`
		Delegate           *url.URL                    `json:"delegate,omitempty"`
		Lockup             uint64                      `json:"lockup,omitempty"`
		HardLock           bool                        `json:"hardLock,omitempty"`
		Status             Status                      `json:"status,omitempty"`
		AcceptingDelegates AcceptingDelegates          `json:"acceptingDelegates,omitempty"`
		ExtraData          *string                     `json:"$epilogue,omitempty"`
	}{}
	if !(v.Identity == nil) {
		u.Identity = v.Identity
	}
	if !(len(v.Accounts) == 0) {
		u.Accounts = v.Accounts
	}
	if !(v.DelegatorPayout == nil) {
		u.DelegatorPayout = v.DelegatorPayout
	}
	if !(!v.RejectDelegates) {
		u.RejectDelegates = v.RejectDelegates
	}
	if !(v.Type == 0) {
		u.Type = v.Type
	}
	if !(v.Stake == nil) {
		u.Stake = v.Stake
	}
	if !(v.Rewards == nil) {
		u.Rewards = v.Rewards
	}
	if !(v.Delegate == nil) {
		u.Delegate = v.Delegate
	}
	if !(v.Lockup == 0) {
		u.Lockup = v.Lockup
	}
	if !(!v.HardLock) {
		u.HardLock = v.HardLock
	}
	if !(v.Status == 0) {
		u.Status = v.Status
	}
	if !(v.AcceptingDelegates == 0) {
		u.AcceptingDelegates = v.AcceptingDelegates
	}
	u.ExtraData = encoding.BytesToJSON(v.extraData)
	return json.Marshal(&u)
}

func (v *Identity) UnmarshalJSON(data []byte) error {
	u := struct {
		Identity           *url.URL                    `json:"identity,omitempty"`
		Accounts           encoding.JsonList[*Account] `json:"accounts,omitempty"`
		DelegatorPayout    *url.URL                    `json:"delegatorPayout,omitempty"`
		RejectDelegates    bool                        `json:"rejectDelegates,omitempty"`
		Type               AccountType                 `json:"type,omitempty"`
		Stake              *url.URL                    `json:"stake,omitempty"`
		Rewards            *url.URL                    `json:"rewards,omitempty"`
		Delegate           *url.URL                    `json:"delegate,omitempty"`
		Lockup             uint64                      `json:"lockup,omitempty"`
		HardLock           bool                        `json:"hardLock,omitempty"`
		Status             Status                      `json:"status,omitempty"`
		AcceptingDelegates AcceptingDelegates          `json:"acceptingDelegates,omitempty"`
		ExtraData          *string                     `json:"$epilogue,omitempty"`
	}{}
	u.Identity = v.Identity
	u.Accounts = v.Accounts
	u.DelegatorPayout = v.DelegatorPayout
	u.RejectDelegates = v.RejectDelegates
	u.Type = v.Type
	u.Stake = v.Stake
	u.Rewards = v.Rewards
	u.Delegate = v.Delegate
	u.Lockup = v.Lockup
	u.HardLock = v.HardLock
	u.Status = v.Status
	u.AcceptingDelegates = v.AcceptingDelegates
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.Identity = u.Identity
	v.Accounts = u.Accounts
	v.DelegatorPayout = u.DelegatorPayout
	v.RejectDelegates = u.RejectDelegates
	v.Type = u.Type
	v.Stake = u.Stake
	v.Rewards = u.Rewards
	v.Delegate = u.Delegate
	v.Lockup = u.Lockup
	v.HardLock = u.HardLock
	v.Status = u.Status
	v.AcceptingDelegates = u.AcceptingDelegates
	v.extraData, err = encoding.BytesFromJSON(u.ExtraData)
	if err != nil {
		return err
	}
	return nil
}
